;Bitte ergänze im Folgenden "Nickname?" durch deinen eigenen, damit man später beim
;Gegeneinanderspielen mehrerer Gegner die Fenster anhand der Titelleisten unterscheiden kann:
AppTitle("Vier-gewinnt-Gegner:Firstdeathmaker?")

Const wx% = 6
Const wy% = 5
Const DIFFICULTY = 4 ;iterationstiefe
Dim Array(wx,wy)

Global WinColumn
Global WinBest

Global LooseColumn
Global LooseBest

Global WinPossibilities
Global LoosePossibilities

Dim Columns(wx)
Dim Possibilities(wx)


;--------------------------------------
Function BesteSpalte%()
;--------------------------------------
   ;Zur Erinnerung:    0 = leer, 1 = rot, 2 = gelb
   ;Mit diesen Werten wird das Spielbrett in dem globalen Array "Feld%(6,5)" gespeichert.
   ;Die unterste Reihe ist die Reihe 0, die oberste Reihe ist die Reihe 5.
   ;Ebenso laufen die Spalten von 0 bis 6 von Links nach Rechts.

   ;RuntimeError("Tja, die Function müsstest DU ermitteln! Darin besteht der Wettbewerb. Das Programm wird beendet.")

   getArray()
   WinBest = -1
   LooseBest = -1
   Local r = isBest()
   Local column
   
      For x=0 To wx
         DebugLog columns(x)
      Next

   If winBest>=0 And LooseBest>=winBest
      DebugLog "Take Winning one"
      column = winColumn
   ElseIf LooseBest>=0
      DebugLog "Take not Loosing one"
      Local tookOne = False
      For x=0 To wx
         If InsertCoin(x,Farbe)
            If Columns(x)>=0
               column = x
               tookOne = True
            EndIf
            RemoveCoin(x,Farbe)
         EndIf
      Next
      
      ;If cannot avoid other win, take that one with the most far end
      If tookOne = False
         Local farest
         For x=0 To wx
            If InsertCoin(x,Farbe)
               If Columns(x)<farest Or (Columns(x)=farest And farest<>0 And Possibilities(x)>Possibilities(column))
                  column = x
                  tookOne = True
                  farest = Columns(x)
               EndIf
               RemoveCoin(x,Farbe)
            EndIf
         Next
      EndIf
      
   Else
   
      ;Take other strategy best one
      For x=0 To wx
         If InsertCoin(x,Farbe)
            If Abs(x - wx/2)<Abs(column - wx/2) ;Bevorzuge Mitte
               column = x
               tookOne = True
            EndIf
            RemoveCoin(x,Farbe)
         EndIf
      Next
      
      DebugLog "take a random one"
   EndIf

   ;Reiner Zufall wäre:
   Return column
;--------------------------------------
End Function
;--------------------------------------



;Returns -1 if this is a bad one
;returns -2 if this is a neutral one
Function isBest(depth% = 0, maxDepth%=DIFFICULTY)
   ;printArray()
   Local ccolor = (Farbe + depth + 1) Mod 2 + 1
   Local r = CheckArray()
   Local w
   Local n
   
   Local tmpWinColumn = 0
   Local tmpWinBest = -1
   
   Local tmpLooseColumn = 0
   Local tmpLooseBest = -1
   
   Local tmpWinPossibilities = 0
   Local tmpLoosePossibilities = 0
   Local tmpPossibilities[wx]
   
   Local tmpColumns%[wx]
   
   If r = Farbe
      ;printArray()
      ;DebugLog "Win possible"
      WinColumn = 0
      WinPossibilities = 1
      WinBest = depth
      Return depth
   ElseIf r <> Farbe And r<>0 And r<>3
      ;DebugLog "Loose possible"
      LooseColumn = 0
      LoosePossibilities = 1
      LooseBest = depth
      Return -depth
   EndIf
   
   If depth >= maxDepth Return 0
   
   For x = 0 To wx
      If InsertCoin(x,ccolor)
         r = isBest(depth + 1, maxDepth)
         tmpColumns[x] = r
         tmpPossibilities[x] = WinPossibilities - LoosePossibilities
         If r>0
            tmpWinPossibilities = tmpWinPossibilities + 1
            If WinBest < tmpWinBest Or tmpWinBest<0
               tmpWinBest = WinBest
               tmpWinColumn = x
               If (depth Mod 2)=1 tmpWinColumn = WinColumn
            EndIf
         ElseIf r<0
            tmpLoosePossibilities = tmpLoosePossibilities + 1
            If LooseBest < tmpLooseBest Or tmpLooseBest<0
               tmpLooseBest = LooseBest
               tmpLooseColumn = x
               If (depth Mod 2)=1 tmpLooseColumn = LooseColumn
            EndIf
         EndIf
         RemoveCoin(x,ccolor)
      EndIf
   Next
   
   WinPossibilities = tmpWinPossibilities
   LoosePossibilities = tmpLoosePossibilities
   
   
   Local lowest%
   For x = 0 To wx
      Columns(x) = tmpColumns[x]
      Possibilities(x) = tmpPossibilities[x]
      If (Abs(lowest) > Abs(tmpColumns[x]) Or lowest = 0) And tmpColumns[x]<>0
         lowest = tmpColumns[x]
      EndIf
   Next
   
   If tmpWinBest>=0
      WinBest = tmpWinBest
      WinColumn = tmpWinColumn
   EndIf

   If tmpLooseBest>=0
      LooseBest = tmpLooseBest
      LooseColumn = tmpLooseColumn
   EndIf

   Return lowest
End Function






Function printArray()
   DebugLog "----"
   Local l$ = ""
   
   For y = wy To 0 Step -1
      l = ""
   For x = 0 To wx
      l = l + Array(x,y)
   Next
   DebugLog l
   Next
End Function

Function getArray()
   For x = 0 To wx
   For y = 0 To wy
      Array(x,y) = Feld(x,y)
   Next
   Next
End Function

Function InsertCoin(column%,player%)
   Local y%
   For y = 0 To wy
      If Array(column,y) = 0
         Array(column,y) = player
         Return 1
      EndIf
   Next
   Return 0
End Function

Function RemoveCoin(column%,player%)
   Local y%
   For y = wy To 0 Step -1
      If Array(column,y) <> 0
         If Array(column,y) = player
            Array(column,y) = 0
            Return 1
         Else
            Return 0
         EndIf
      EndIf
   Next
   Return 0
End Function


Function CheckArray%()
   ;gibt 0 zurück, falls das Spiel noch nicht zu Ende ist.
   ;gibt 1 zurück, wenn Rot gewonnen hat, und 2 zurück, wenn Gelb gewonnen hat
   ;gibt 3 zurück, wenn keiner gewonnen hat, das Spielbrett aber voll ist: Remis!
   Local Reihe%, Spalte%, ObereSumme%
   ;Waagerechte Viererreihen:
   For Spalte = 0 To 3
      For Reihe = 0 To 5
            If Array(Spalte, Reihe) > 0 And Array(Spalte+1, Reihe) = Array(Spalte, Reihe) And Array(Spalte+2, Reihe) = Array(Spalte, Reihe) And Array(Spalte+3, Reihe) = Array(Spalte, Reihe) Then Return Array(Spalte, Reihe)
      Next
   Next
   ;Senkrechte Viererreihen:
   For Spalte = 0 To 6
      For Reihe = 0 To 2
         If Array(Spalte, Reihe) > 0 And Array(Spalte, Reihe+1) = Array(Spalte, Reihe) And Array(Spalte, Reihe+2) = Array(Spalte, Reihe) And Array(Spalte, Reihe+3) = Array(Spalte, Reihe) Then Return Array(Spalte, Reihe)
      Next
      ObereSumme = ObereSumme + (Array(Spalte, 5)+1)/2
   Next
   ;Diagonale Viererreihen (zwei Möglichkeiten):
   For Spalte = 0 To 3
      For Reihe = 0 To 2
         If Array(Spalte, Reihe) > 0 And Array(Spalte, Reihe) = Array(Spalte+1, Reihe+1) And Array(Spalte, Reihe) = Array(Spalte+2, Reihe+2) And Array(Spalte, Reihe) = Array(Spalte+3, Reihe+3) Then Return Array(Spalte, Reihe)
         If Array(Spalte, Reihe+3) > 0 And Array(Spalte, Reihe+3) = Array(Spalte+1, Reihe+2) And Array(Spalte, Reihe+3) = Array(Spalte+2, Reihe+1) And Array(Spalte, Reihe+3) = Array(Spalte+3, Reihe) Then Return Array(Spalte, Reihe+3)
      Next
   Next
   ;Remis?
   If ObereSumme = 7 Then Return 3
   ;Ansonsten gar nichts:
   Return 0
End Function 
